'From Squeak3.7beta of ''1 April 2004'' [latest update: #5963] on 17 July 2004 at 11:42:59 pm'!

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/26/2004 18:05'!
initializeFromSixxElement: sixxElement context: aDictionary 
	self class isBits
		ifTrue: [^ self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary].
	self class isVariable
		ifTrue: [^ self initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary].
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary! !

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 03:54'!
initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary 
	| idx nonameElems |
	idx := 1.
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self class nameFromSixxElement: each) isNil].
	nonameElems isEmpty
		ifFalse: [nonameElems
				do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
						ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxAt: idx put: childInst.
							idx := idx + 1]]]! !

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/26/2004 18:04'!
initializeInstVarsFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/26/2004 18:05'!
initializeMixedFieldsFromSixxElement: sixxElement context: aDictionary 
	self initializeInstVarsFromSixxElement: sixxElement context: aDictionary.
	self initializeIndexFieldsFromSixxElement: sixxElement context: aDictionary ! !

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 01:12'!
sixxAt: index put: aValue 
	"override if you like"
	self at: index put: aValue ! !

!Object methodsFor: 'initializing-sixx' stamp: 'mu 6/24/2004 21:40'!
sixxInitialize
	"override if you like"
	"The method is called after the loading of the receiver - just like #initializaAfterLoad in Envy"
	"It is useful to initializa attributes that cannot be stored in SIXX (Block, Context, etc)"! !

!Object methodsFor: 'initializing-sixx' stamp: 'MU 6/9/2002 19:30'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	self
		instVarAt: (self class allInstVarNames indexOf: instVarName asString)
		put: aValue! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:34'!
sixxContentOn: aStream indent: level context: dictionary
	"override if you like"
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.
! !

!Object methodsFor: 'printing-sixx' stamp: 'kuri-t 5/17/2002 14:27'!
sixxOn: aStream 
	self sixxOn: aStream indent: 0 context: IdentityDictionary new! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream indent: level context: dictionary
	^self sixxOn: aStream name: nil indent: level context: dictionary! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	aStream tab: level.
	(dictionary includesKey: self)
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: self) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: self put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:34'!
sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 6/26/2004 16:45'!
sixxChildrenContentsOn: aStream indent: level context: dictionary 
	self class isBits
		ifTrue: [aStream nextPutAll: '#( '.
			1 to: self size do: [:idx | 
				aStream nextPutAll: (self at: idx) asString; space
			].
			aStream nextPutAll: ')'.
			^ self].
		
	self class isVariable
		ifTrue: [^ self
				sixxMixedFieldsOn: aStream
				indent: level
				context: dictionary].
			
	self
		sixxInstVarsOn: aStream
		indent: level
		context: dictionary! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:45'!
sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:45'!
sixxEnvAttribString
	^'sixx.env="' , self sixxEnv , '" '! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxIdAttribString: idString
	^'sixx.id="', idString asString, '" '! !

!Object methodsFor: 'private-sixx' stamp: 'mu 6/25/2004 04:32'!
sixxIndexFieldsOn: aStream indent: level context: dictionary 
	"override if you like"
	| size |
	size := self basicSize.
	size = 0
		ifTrue: [^ self].
	1
		to: size
		do: [:i | 
			| element | 
			element := self basicAt: i.
			element
				sixxOn: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: 'private-sixx' stamp: 'mu 6/26/2004 16:53'!
sixxInstVarsOn: aStream indent: level context: dictionary
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars do: 
			[:nm | 
			ind := ind + 1.
			(self instVarAt: ind) 
				sixxOn: aStream
				name: nm
				indent: level
				context: dictionary]! !

!Object methodsFor: 'private-sixx' stamp: 'mu 6/26/2004 16:45'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxNameAttribString: idString
	^'sixx.name="', idString asString, '" '! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil
		ifFalse: [wStr
				nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil
		ifTrue: [wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents
	! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:47'!
sixxTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	SixxSetting useEnvironment ifTrue: [wStr nextPutAll: self sixxEnvAttribString.].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxType
	^self class name! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxTypeAttribString
	^'sixx.type="', self sixxType, '" '! !


!Behavior methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 03:25'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	^ aClass isVariable
		ifTrue: [self createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement]
		ifFalse: [self sixxNew: aClass withSixxElement: sixxElement]! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 03:25'!
createMixedFieldsInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	| nonameElems size |
	nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
				select: [:each | (self nameFromSixxElement: each) isNil].
	size := nonameElems isEmpty
				ifTrue: [0]
				ifFalse: [nonameElems size].
	^ self
		sixxNew: aClass
		size: size
		withSixxElement: sixxElement! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/20/2002 14:05'!
readSixxFrom: xmlStringOrStream 
	^ self readSixxFrom: xmlStringOrStream context: IdentityDictionary new! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/20/2002 14:04'!
readSixxFrom: xmlStringOrStream context: aDictionary 
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^ self readSixxFromSixxElement: topElem context: aDictionary! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 6/3/2002 16:29'!
readSixxFromSixxElement: sixxElement context: aDictionary 
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil
		ifTrue: [(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: [rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil
				ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'mu 6/26/2004 16:21'!
sixxNew: aClass size: size withSixxElement: sixxElement 
	^ [aClass new: size]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [[aClass basicNew: size] on: Error do: [self sixxNew: aClass withSixxElement: sixxElement ]]
				ifFalse: [alterClass basicNew: size]]! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'mu 6/24/2004 22:20'!
sixxNew: aClass withSixxElement: sixxElement 
	^[aClass new]
		on: Error
		do: [:ex | 
			| alterClass | 
			alterClass := SixxNewFailed signal: aClass name element: sixxElement.
			alterClass isNil
				ifTrue: [aClass basicNew]
				ifFalse: [alterClass basicNew]]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 12:57'!
classFromSixxElement: sixxElement context: dictionary 
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil
		ifTrue: [^ nil].
	className := (type includes: Character space)
				ifTrue: [isClassClass := true.
					type copyUpTo: Character space]
				ifFalse: [type].
	retClass := SixxPortableUtil
				classAt: className
				in: (self envFromSixxElement: sixxElement).
	isClassClass
		ifTrue: [retClass := retClass class].
	^ retClass isNil
		ifTrue: [SixxClassNotFound
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 12:57'!
envFromSixxElement: sixxElement 
	| environmentQualifier |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	environmentQualifier := SixxXmlUtil attributeAt: #'sixx.env' from: sixxElement.
	^ environmentQualifier isNil
		ifFalse: [environmentQualifier asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 5/31/2002 15:21'!
fromSixxElement: sixxElement context: aDictionary 
	^ (self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
idFromSixxElement: sixxElement 
	| id |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	id := SixxXmlUtil attributeAt: #'sixx.id' from: sixxElement .
	^ id isNil
		ifFalse: [id asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
idrefFromSixxElement: sixxElement
	| idref |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	idref := SixxXmlUtil attributeAt: #'sixx.idref' from: sixxElement .
	^ idref isNil
		ifFalse: [idref asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 6/3/2002 16:06'!
includesRefInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^ idref isNil
		ifTrue: [false]
		ifFalse: [aDictionary includesKey: idref]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
nameFromSixxElement: sixxElement 
	| nm |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	nm := SixxXmlUtil attributeAt: #'sixx.name' from: sixxElement .
	^ nm isNil
		ifFalse: [nm asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'mu 6/24/2004 22:23'!
newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst |
	class := self classFromSixxElement: sixxElement context: aDictionary .
	class isNil
		ifTrue: [class := SixxClassNotFound
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	aDictionary
		at: (self idFromSixxElement: sixxElement)
		put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	inst sixxInitialize.
	^ inst! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/14/2002 19:43'!
refInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
typeFromSixxElement: sixxElement 
	| type |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	type := SixxXmlUtil attributeAt: #'sixx.type' from: sixxElement.
	^ type isNil
		ifFalse: [type asSymbol]! !


!Boolean methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 16:20'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !


!Character methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:37'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString
	! !


!ClassDescription methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:32'!
sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex  |	
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size do: [:idx | 
			(self instVarAt: idx)
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary].! !


!Boolean class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:16'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!Character class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:17'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!Collection methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 03:59'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | 
			| childInst | 
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]! !

!Collection methodsFor: 'printing-sixx' stamp: 'mu 6/25/2004 00:37'!
sixxContentOn: aStream indent: level context: dictionary
	"default just uses #do: - override it to use #sixxAllFieldsOn:indent:context: if your collection need to store some inst vars"
	aStream cr.
	self
		do: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!Collection methodsFor: 'private-sixx' stamp: 'mu 6/25/2004 04:55'!
sixxIndexFieldsOn: aStream indent: level context: dictionary
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]

! !

!Collection methodsFor: 'private-sixx' stamp: 'mu 6/25/2004 04:55'!
sixxMixedFieldsOn: aStream indent: level context: dictionary
	"override"
	"Usually Collection's inst vars are not needed for serialization"
	self sixxIndexFieldsOn: aStream indent: level context: dictionary.! !


!ArrayedCollection methodsFor: 'initializing-sixx' stamp: 'mu 6/25/2004 03:44'!
initializeFromSixxElement: sixxElement context: aDictionary 
	"override to use #initializeMixedFieldsFromSixxElement:context: if having some inst vars"
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !


!ByteArray methodsFor: 'converting' stamp: 'minami 7/14/2004 00:42'!
shortHexString
	| sz stream |
	sz := self size.
	stream := WriteStream on: (String new: sz * 2).
	1 to: sz do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [stream nextPut: $0].
		stream nextPutAll:  elem shortHexString].
	^ stream contents  ! !

!ByteArray methodsFor: 'printing-sixx' stamp: 'minami 7/14/2004 00:43'!
sixxContentOn: aStream indent: level context: dictionary 
	1 to: self size do: [:idx | 
		| elem |
		elem := (self at: idx).
		elem < 16 ifTrue: [aStream nextPut: $0].
		aStream nextPutAll: elem shortHexString].
	! !


!Collection class methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 03:32'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override to use #createMixedFieldsInstanceOf:withSixxElement: if you have extra inst vars"
	^ self
		sixxNew: aClass
		size: (SixxXmlUtil elementsFrom: sixxElement) size
		withSixxElement: sixxElement! !


!ByteArray class methodsFor: 'instance creation-sixx' stamp: 'mu 6/26/2004 18:36'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| rawStr col |
	rawStr := ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement).
	col := rawStr peek = $#
				ifTrue: [Array readFrom: rawStr]
				ifFalse: [self readShortHexFrom: rawStr].
	^ self withAll: col! !

!ByteArray class methodsFor: 'instance creation' stamp: 'minami 7/14/2004 01:00'!
readShortHexFrom: aStream
	| sz inst |
	sz := aStream size // 2.
	inst := self new: sz.
	1 to: sz do: [:idx | 
		inst at: idx put: (Integer readShortHexFrom: (aStream next: 2) readStream)
	].
	^ inst! !


!Date methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !


!Date class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!Dictionary methodsFor: 'printing-six' stamp: 'mu 5/10/2002 14:33'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		associationsDo: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !


!Interval methodsFor: 'printing-sixx' stamp: 'minami 3/18/2003 01:47'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString! !


!Interval class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:22'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!Metaclass methodsFor: 'instance creation-sixx' stamp: 'MU 9/2/2002 02:46'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ aClass isMeta
		ifTrue: [aClass soleInstance]
		ifFalse: [aClass]! !


!Number methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self asString
	! !


!Integer methodsFor: 'printing' stamp: 'mu 6/26/2004 12:11'!
shortHexString
	| current letters digits quo i |
	digits := '0123456789ABCDEF'.
	current := self.
	i := self digitLength * 8.
	letters := String new: i.
	[current < 16] whileFalse: 
		[quo := current quo: 16.
		letters at: i put: (digits at: (current - (quo * 16)) + 1).
		i := i - 1.
		current := quo].
	letters at: i put: (digits at: current + 1).
	^letters copyFrom: i to: letters size! !


!Number class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ (SixxXmlUtil characterDataFrom: sixxElement) asNumber
	! !


!Integer class methodsFor: 'instance creation' stamp: 'mu 6/26/2004 10:25'!
readShortHexFrom: aStream 
	| digit value startPos |
	value := 0.
	startPos := aStream position.
	[aStream atEnd]
		whileFalse: 
			[digit := aStream next digitValue.
			(digit < 0 or: [digit >= 16])
				ifTrue: 
					[aStream skip: -1.
					aStream position = startPos ifTrue: [self error: 'At least one digit expected here'].
					^ value]
				ifFalse: [value := value * 16 + digit]].
	^ value! !


!Point methodsFor: 'printing-sixx' stamp: 'mu 6/25/2004 20:23'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: x printString.
	aStream nextPut: $@.
	aStream nextPutAll: y printString.
	
	! !


!Point class methodsFor: 'instance creation-sixx' stamp: 'mu 6/25/2004 20:31'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| readStr x y |
	readStr := ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement).
	x _ (readStr upTo: $@) asNumber.
	y _ (readStr upToEnd) asNumber.
	^self x: x y: y! !


!RunArray methodsFor: 'initializing-sixx' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!RunArray methodsFor: 'printing-sixx' stamp: 'MU 7/9/2002 01:25'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream cr.
	self runs
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !


!RunArray class methodsFor: 'instance creation-sixx' stamp: 'MU 7/21/2002 23:30'!
createInstanceOf: aClass withSixxElement: sixxElement
	"squeak specific"
	
	^aClass basicNew! !


!String methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 20:04'!
sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !


!String class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ SixxXmlUtil characterDataFrom: sixxElement! !


!Symbol class methodsFor: 'instance creation-sixx' stamp: 'mu 5/9/2002 17:46'!
createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !


!Text methodsFor: 'initializing-sixx' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst ]]]! !

!Text methodsFor: 'printing-sixx' stamp: 'MU 7/9/2002 01:11'!
sixxContentOn: aStream indent: level context: dictionary
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.! !


!Time methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !


!Time class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:23'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!UndefinedObject methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!UndefinedObject methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 18:56'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	| key |
	key := self asSixxKey.
	aStream tab: level.
	(dictionary includesKey: key )
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: key) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: key put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!UndefinedObject methodsFor: 'private-sixx' stamp: 'MU 9/16/2002 18:55'!
asSixxKey
	"For some Smalltalks which do not support nil element in IdentityDictionary"
	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'
! !


!UndefinedObject class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:20'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!WordArray methodsFor: 'printing-sixx' stamp: 'MU 6/29/2002 16:00'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !


!WordArray class methodsFor: 'instance creation-sixx' stamp: 'MU 5/24/2003 18:21'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (ReadStream on: (SixxXmlUtil characterDataFrom: sixxElement)).
	^ col asWordArray! !

